#ifndef _DEF_PLAYER
#define _DEF_PLAYER

#include "vec.h"
#include "camera.h"
#include "input.h"

typedef struct Player
{
	Vec pos;
	Vec hbox; /* the bottom left corner of the player's hitbox */
	Vec vbox; /* the bottom left corner of the player's visual box */
	Vec origin; /* the origin of the player (offset) */
} Player;

void player_step(Player *player, Input *input);
void player_draw(Player *player, Camera *camera);
void player_draw_debug(Player *player, uint step);

#endif /* _DEF_PLAYER */
